/*
 * Copyright 2011 Red Hat, Inc.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation files
 * (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software,
 * and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#ifndef DATAQUEUE_H_
#define DATAQUEUE_H_

#include <stdbool.h>
#include <stddef.h>

typedef struct dataqueue dataqueue;

dataqueue *
dataqueue_new(void);

bool
dataqueue_push(dataqueue *queue, bool newl, const char *data);

bool
dataqueue_push_len(dataqueue *queue, bool newl, const char *data, size_t len);

const char *
dataqueue_peek(dataqueue *queue);

char *
dataqueue_pop(dataqueue *queue);

void
dataqueue_partial(dataqueue *queue, size_t size);

size_t
dataqueue_len(dataqueue *queue);

void
dataqueue_free(dataqueue *queue);

#endif /* DATAQUEUE_H_ */
